Add list argument, add script for shellcheck fix

This commit is contained in:
flyingscorpio@arch-desktop 2020-04-24 16:27:42 +02:00
parent 022e3a8a72
commit bc7f7dd9e3
2 changed files with 56 additions and 5 deletions

View file

@ -142,22 +142,23 @@ class Installer:
failed_installs = []
ui.info_2("Installing packages...")
for package in packages:
for i, package in enumerate(packages):
if self.operating_system == "arch based":
command = "sudo pacman -S --needed --noconfirm {}"\
.format(package)
elif self.operating_system == "debian based":
command = "sudo apt install -y {}".format(package)
ui.info_count(i, len(packages), package, end="... ")
install = subprocess.run(command, check=False, shell=True,
stdout=subprocess.DEVNULL,
stderr=subprocess.DEVNULL)
if install.returncode != 0:
ui.info(ui.cross, package)
ui.info(ui.cross)
failed_installs.append(package)
else:
ui.info(ui.check, package)
ui.info(ui.check)
if len(failed_installs) > 0:
ui.warning("These packages failed to install:")
@ -177,8 +178,10 @@ class Installer:
ui.info_2("Running", "`{}`".format(command))
runned = subprocess.run(command, check=False, shell=True)
if runned.returncode != 0:
ui.warning("`{}` failed".format(command))
self.base_dir.chdir()
def do_symlink(self, src: str, dest: str, condition: str = "true") -> None:
@ -263,7 +266,7 @@ class Installer:
if not programs:
ui.info("No programs were specified.",
"Fetching from the configuration file.")
programs = sorted(self.conf.keys())
programs = list(self.conf.keys())
for program in programs:
if ui.ask_yes_no("Do you wish to install {}?".format(program)):
self.install_program(program)
@ -339,6 +342,12 @@ def main() -> None:
action="store_true",
help="Overwrite existing files",
)
parser.add_argument(
"-l",
"--list_programs",
action="store_true",
help="List all programs from the configuration file.",
)
parser.add_argument(
"--update",
action="store_true",
@ -349,10 +358,18 @@ def main() -> None:
programs = args.programs
force = args.force
list_programs = args.list_programs
update = args.update
installer = Installer(force=force, update=update)
installer.install(programs=programs)
if list_programs:
ui.info("The following items were found in the config file:")
for program in installer.conf.keys():
ui.info_1(program)
else:
installer.install(programs=programs)
if __name__ == "__main__":

34
shellcheck_binary_fix.sh Executable file
View file

@ -0,0 +1,34 @@
#!/bin/bash
## This script is a workaround for installing shellcheck with the precompiled
# binary. It is intended to be run when the shellcheck package isn't found via
# pacman.
RED=$(tput setaf 1)
GREEN=$(tput setaf 2)
ORANGE=$(tput setaf 3)
NC=$(tput sgr0)
if ! sudo pacman -S --needed shellcheck; then
echo " ${ORANGE}Shellcheck was not found with pacman, downloading pre-compiled binary${NC}"
scversion="stable"
architechture=$(uname -m)
if [ -e ~/Downloads/shellcheck-${scversion} ]; then
rm -r ~/Downloads/shellcheck-${scversion} && echo " ${ORANGE}Found and removed pre-existing shellcheck folder${NC}"
fi
cd ~/Downloads || exit 1
echo " Downloading shellcheck ${scversion} binary for ${architechture}..."
if wget -qO- "https://storage.googleapis.com/shellcheck/shellcheck-${scversion?}.linux.${architechture?}.tar.xz" | tar -xJv; then
echo " ${GREEN}Successfully downloaded and extracted shellcheck.${NC}"
echo " Copying executable to /usr/bin/ ..."
sudo cp "shellcheck-${scversion}/shellcheck" /usr/bin/ && shellcheck --version
if rm -r ~/Downloads/shellcheck-${scversion}; then
echo " ${GREEN}Removed shellcheck installation folder${NC}"
else
echo " ${RED}Was unable to remove shellcheck installation folder${NC}"
exit 1
fi
else
echo " ${RED}Was unable to download shellcheck binary${NC}"
fi
fi